!= ͥǡ
!
!= Prepare initial data
!
! Authors::   Yasuhiro MORIKAWA
! Version::   $Id: initial_data.F90,v 1.4 2010-01-22 07:17:25 yot Exp $ 
! Tag Name::  $Name:  $
! Copyright:: Copyright (C) GFD Dennou Club, 2008. All rights reserved.
! License::   See COPYRIGHT[link:../../../COPYRIGHT]
!

module initial_data
  !
  != ͥǡ
  !
  != Prepare initial data
  !
  ! ͥǡΥץ󶡤ޤ. 
  ! 
  ! ߤϰʲΥǡ󶡤ޤ. 
  ! 
  ! * Small Disturbance of Temperature
  !   * ®: 0 [m/s], ɽ̵: 1.0e+5 [Pa], 漾: 1.0e-10 [kg kg-1]
  !   * : 250 [K] ä
  !
  ! * [AGCM 5.3]{http://www.gfd-dennou.org/library/agcm5} Default
  !   * ®: 0 [m/s], ɽ̵: 1.0e+5 [Pa], 漾: 1.0e-10 [kg kg-1]
  !   * : 250 [K] ä
  ! 
  ! * Sugiyama et al. (2008)
  !   * 絤ꤷ, Sugiyama et al. (2008) ѤƤ
  !     ͤ魯. 
  !   * ®: 0 [m/s], ɽ̵: 3.0e+6 [Pa]
  !   * : $ \sigma = 1 $  490 [K] Ȥ,  1.0e+4 Ȥʤ٤ޤ, 
  !     ̰ (Ǯ˱ä) ٤ȼ٤򸺾. 
  !      1.0e+4 ʲι٤ǤϲٰȤ. 
  !   * 漾: $ \sigma = 1 $  6.11641e-3 [kg kg-1] Ȥ, 
  !     漾˰漾 75 % Ȥʤ٤ޤǤϰȤ. 
  !     ιٰʾǤ, 漾˰漾 75 % Ȥ. 
  !
  ! * Polvani et al. (2004)
  !   * Polvani et al.(2004) ͿͤȤ, ԰ˤ
  !     𤬤ɤΤ褦ȯã뤫ͷ׻.
  !
  ! Prepare sample data of initial data (restart data)
  !
  ! Now, following data are provided. 
  ! 
  ! * Small Disturbance of Temperature
  !   * Velocity: 0 [m/s], Surface pressure: 1.0e+5 [Pa], 
  !     Specific humidity: 1.0e-10 [kg kg-1]
  !   * Temperature: 250 [K] and perturbation
  !
  ! * [AGCM 5.3]{http://www.gfd-dennou.org/library/agcm5} Default
  !   * Velocity: 0 [m/s], Surface pressure: 1.0e+5 [Pa], 
  !     Specific humidity: 1.0e-10 [kg kg-1]
  !   * Temperature: 250 [K] and perturbation
  ! 
  ! * Sugiyama et al. (2008)
  !   * Initial data like a Jovian atmosphere  
  !     that is used in Sugiyama et al. (2008) is imitated. 
  !   * Velocity: 0 [m/s], Surface pressure: 3.0e+6 [Pa]
  !   * Temperature: 490 [K] at $ \sigma = 1 $ . 
  !     And it is declined with constant potential temperature
  !     (along dry adiabat line) 
  !     below where air pressure is 1.0e+4. 
  !     It is constant above where air pressure is 1.0e+4. 
  !   * Specific humidity: 6.11641e-3 [kg kg-1] at $ \sigma = 1 $ .
  !     And it is constant below where it is same as 75 % of 
  !     saturation specific humidity. 
  !     Above that, specific humidity is 75 % of saturation specific humidity. 
  ! * Polvani et al. (2004)
  !
  !== Procedures List
  !
  ! SetInitData   :: ͥǡ
  ! ------------  :: ------------
  ! SetInitData   :: Get initial data
  !
  !== NAMELIST
  !
  ! NAMELIST#initial_data_nml
  !

  ! ⥸塼 ; USE statements
  !

  ! ʻ
  ! Grid points settings
  !
  use gridset, only: imax, & ! ٳʻ. 
                             ! Number of grid points in longitude
    &                jmax, & ! ٳʻ. 
                             ! Number of grid points in latitude
    &                kmax    ! ľؿ. 
                             ! Number of vertical level

  ! ̷ѥ᥿
  ! Kind type parameter
  !
  use dc_types, only: DP, &      ! ټ¿. Double precision. 
    &                 STRING     ! ʸ.       Strings. 

  ! ̷ѥ᥿
  ! Kind type parameter
  !
  use dc_types, only: DP     ! ټ¿. Double precision. 

  ! å
  ! Message output
  !
  use dc_message, only: MessageNotify

  ! ʸ ; Declaration statements
  !
  implicit none
  private

  ! ³
  ! Public procedure
  !
  public:: SetInitData

  ! ѿ
  ! Public variables
  !
  logical, save, public:: initial_data_inited = .false.
                              ! ե饰. 
                              ! Initialization flag

  character(STRING), save, public:: Pattern
                              ! ͥǡΥѥ. 
                              ! ʲΥѥǽ. 
                              ! 
                              ! Initial data pattern
                              ! Available patterns are as follows.
                              ! 
                              ! * "Small Disturbance of Temperature" (default value)
                              ! * "AGCM 5.3 Default"
                              ! * "Sugiyama et al. (2008)"
                              ! 
  real(DP), save, public:: TempAvr
                              ! $ \bar{T} $ .     ʿ. Mean temperature
  real(DP), save, public:: PsAvr
                              ! $ \bar{p_s} $ .   ɽ̵ʿ. Mean surface pressure
  real(DP), save, public:: QVapAvr
                              ! $ \bar{q} $ .     漾ʿ. Mean specific humidity
  real(DP), save, public:: Ueq
                              ! $ u_{eq} $ .      ƻ®. Eastward wind on the equator

  ! ѿ
  ! Private variables
  !
  character(*), parameter:: saturate_scheme = &
#ifdef LIB_SATURATE_NHA1992
    & 'Nakajima et al. (1992)'
#elif LIB_SATURATE_T1930
    & 'Tetens (1930)'
#else
    & 'Tetens (1930)'
#endif

  character(*), parameter:: module_name = 'initial_data'
                              ! ⥸塼̾. 
                              ! Module name
  character(*), parameter:: version = &
    & '$Name:  $' // &
    & '$Id: initial_data.F90,v 1.4 2010-01-22 07:17:25 yot Exp $'
                              ! ⥸塼ΥС
                              ! Module version

  ! INTERFACE ʸ ; INTERFACE statements
  !
  interface SetInitData
    module procedure SetInitData
  end interface

contains

  subroutine SetInitData( &
    & xyz_U, xyz_V, xyz_Temp, xyz_QVap, xy_Ps &   ! (out)
    & )
    !
    ! ͥǡΥץ󶡤ޤ. 
    ! 
    ! Prepare sample data of initial data
    !

    ! ⥸塼 ; USE statements
    !

    ! ɸǡ
    ! Axes data settings
    !
    use axesset, only: &
      & x_Lon, &
                              ! $ \lambda $ [rad.] . . Longitude
      & y_Lat, &
                              ! $ \varphi $ [rad.] . . Latitude
      & z_Sigma
                              ! $ \sigma $ ٥ (). 
                              ! Full $ \sigma $ level

    ! ʪ
    ! Physical constants settings
    !
    use constants, only: &
      & CpDry, &              ! $ C_p $ [J kg-1 K-1].
                              ! 絤갵Ǯ.
                              ! Specific heat of air at constant pressure
      & GasRDry, &            ! $ R $ [J kg-1 K-1].
                              ! 絤ε.
                              ! Gas constant of air
      & PI                    ! $ \pi $.
                              ! ߼Ψ. Circular constant

    ! ʸ
    ! Character handling
    !
    use dc_string, only: LChar

    ! ʸ ; Declaration statements
    !
    implicit none
    real(DP), intent(out):: xyz_U  (0:imax-1, 1:jmax, 1:kmax)
                              ! $ u $ .   ®. Eastward wind
    real(DP), intent(out):: xyz_V  (0:imax-1, 1:jmax, 1:kmax)
                              ! $ v $ .   ®. Northward wind
    real(DP), intent(out):: xyz_Temp  (0:imax-1, 1:jmax, 1:kmax)
                              ! $ T $ .   . Temperature
    real(DP), intent(out):: xyz_QVap  (0:imax-1, 1:jmax, 1:kmax)
                              ! $ q $ .   漾. Specific humidity
    real(DP), intent(out):: xy_Ps (0:imax-1, 1:jmax)
                              ! $ p_s $ . ɽ̵. Surface pressure


    ! ѿ
    ! Work variables
    !
    integer:: i               ! ˲ DO 롼Ѻѿ
                              ! Work variables for DO loop in longitude
    integer:: j               ! ˲ DO 롼Ѻѿ
                              ! Work variables for DO loop in latitude
    integer:: k               ! ľ˲ DO 롼Ѻѿ
                              ! Work variables for DO loop in vertical direction


    !call flush(90)

    ! ¹ʸ ; Executable statement

    if ( .not. initial_data_inited ) call InitDataInit

    select case ( LChar( trim(Pattern) ) )

    ! ʲپΤŻ߾
    ! Stationary field with small disturbance of temperature
    !
    case ( 'small disturbance of temperature' )
      xyz_U    = 0.0_DP
      xyz_V    = 0.0_DP
      xyz_Temp = TempAvr
      xy_Ps    = PsAvr
      xyz_QVap = QVapAvr

      ! ٤˾Ϳ
      ! Add perturbation to temperature
      !
      do k = 1, kmax
        do j = 1, jmax
          do i = 0, imax - 1
            xyz_Temp(i,j,k) = &
              &    xyz_Temp(i,j,k) &
              &  + 0.1_DP * sin ( x_Lon(i) * y_Lat(j) ) &
              &  - 0.1_DP * ( 1.0_DP - z_Sigma(k) )
          end do
        end do
      end do

    write(*,*) 'small%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%'

      ! ®Ϳ
      ! Add eastward wind
      !
      do j = 1, jmax
        xyz_U(:,j,:) = Ueq * cos(y_Lat(j))
      end do


    ! AGCM5.3 ΥǥեȽ
    ! AGCM5.3 default initial values
    !
    case ( 'agcm 5.3 default' )
      xyz_U    = 0.0_DP
      xyz_V    = 0.0_DP
      xyz_Temp = TempAvr
      xy_Ps    = PsAvr
      xyz_QVap = QVapAvr

    write(*,*) 'agcm%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%'

      ! ٤˾Ϳ
      ! Add perturbation to temperature
      !
      do k = 1, kmax
        do j = 1, jmax
          do i = 0, imax - 1
            xyz_Temp(i,j,k) = &
              &    xyz_Temp(i,j,k) &
              &  + 0.1_DP &
              &    * sin ( real( ( i + 1 ) &
              &                  * ( jmax - j + 1 ) &
              &                  * ( kmax - k ), DP ) &
              &            / real( imax &
              &                    * jmax &
              &                    * kmax, DP ) * 10.0_DP &
              &                 )
          end do
        end do
      end do

      ! ®Ϳ
      ! Add eastward wind
      !
      do j = 1, jmax
        xyz_U(:,j,:) = Ueq * cos(y_Lat(j))
      end do

    ! Sugiyama et al. (2008) ν
    ! Initial values of Sugiyama et al. (2008)
    !
!    case ( 'sugiyama et al. (2008)' )
!
!      call Sugiyamaetal2008InitData( &
!        & xyz_U, xyz_V, xyz_Temp, xyz_QVap, xy_Ps &   ! (out)
!        & )

    ! Polvani et al. (2004) ν
    ! Initial values of Polvani et al. (2004)
    !
    case ( 'polvani et al. (2004)' )

    write(*,*) '%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%'

      call polvanietal2004InitData( &
        & xyz_U, xyz_V, xyz_Temp, xyz_QVap, xy_Ps &   ! (out)
        & )

    end select

  end subroutine SetInitData

  !-------------------------------------------------------------------
!
!  subroutine Sugiyamaetal2008InitData( &
!    & xyz_U, xyz_V, xyz_Temp, xyz_QVap, xy_Ps &   ! (out)
!    & )
!    !
!    ! Sugiyama et al. (2008) ν
!    ! Initial values of Sugiyama et al. (2008)
!    !
!
!    ! ⥸塼 ; USE statements
!    !
!
!    ! ɸǡ
!    ! Axes data settings
!    !
!    use axesset, only: &
!      & x_Lon, &
!                              ! $ \lambda $ [rad.] . . Longitude
!      & y_Lat, &
!                              ! $ \varphi $ [rad.] . . Latitude
!      & z_Sigma
!                              ! $ \sigma $ ٥ (). 
!                              ! Full $ \sigma $ level
!
!    ! ʪ
!    ! Physical constants settings
!    !
!    use constants, only: &
!      & CpDry, &              ! $ C_p $ [J kg-1 K-1]. 
!                              ! 絤갵Ǯ. 
!                              ! Specific heat of air at constant pressure
!      & GasRDry               ! $ R $ [J kg-1 K-1]. 
!                              ! 絤ε. 
!                              ! Gas constant of air
!
!    ! ˰漾׻
!    ! Evaluate saturation specific humidity
!    !
!#ifdef LIB_SATURATE_NHA1992

  !-------------------------------------------------------------------

  subroutine polvanietal2004InitData( &
    & xyz_U, xyz_V, xyz_Temp, xyz_QVap, xy_Ps &   ! (out)
    & )
    !
    ! Polvani et al. (2004) ν
    ! 
    ! Polvani et al. (2004) of initial data
    !

    ! ⥸塼 ; USE statements
    !

    ! ɸǡ
    ! Axes data settings
    !
    use axesset, only: &
      & x_Lon, &
                              ! $ \lambda $ [rad.] . . Longitude
      & y_Lat, &
                              ! $ \varphi $ [rad.] . . Latitude
      & z_Sigma, &
                              ! $ \sigma $ ٥ (). 
                              ! Full $ \sigma $ level
      & y_Lat_Weight
                              ! $ \Delta \varphi $ [rad.] .
                              ! ٺɸŤ.
                              ! Weight of latitude
    ! ʪ
    ! Physical constants settings
    !
    use constants, only: &
      & PI                    ! $ \pi $.
                              ! ߼Ψ. Circular constant

    ! ʸ
    ! Character handling
    !
    use dc_string, only: LChar


    ! ʸ ; Declaration statements
    !
    implicit none
    real(DP), intent(out):: xyz_U  (0:imax-1, 1:jmax, 1:kmax)
                              ! $ u $ .   ®. Eastward wind
    real(DP), intent(out):: xyz_V  (0:imax-1, 1:jmax, 1:kmax)
                              ! $ v $ .   ®. Northward wind
    real(DP), intent(out):: xyz_Temp  (0:imax-1, 1:jmax, 1:kmax)
                              ! $ T $ .   . Temperature
    real(DP), intent(out):: xyz_QVap  (0:imax-1, 1:jmax, 1:kmax)
                              ! $ q $ .   漾. Specific humidity
    real(DP), intent(out):: xy_Ps (0:imax-1, 1:jmax)
                              ! $ p_s $ . ɽ̵. Surface pressure

    ! ѥ᥿
    ! 
    !
    !

    real(DP), parameter:: omega = 7.292_DP*10.0**(-5)
                              ! $ \omega $ [s^-1]
                              !  constants ⥸塼뤫Ѥ٤Ǥä
    real(DP), parameter:: a = 6.371_DP*10.0**6
                              ! $ a $ [m]
                              !  constants ⥸塼뤫Ѥ٤Ǥä
    real(DP), parameter:: R = 287_DP
                              ! $ R $[J kg^-1 K^-1]
                              !  constants ⥸塼뤫Ѥ٤Ǥä
    real(DP), parameter:: ScaleHeight = 7.34_DP
                              ! $ z $ [km]
    real(DP), parameter:: dz_0 = 5_DP
                              ! $ dz_0 $ [km].
    real(DP), parameter:: z_0 = 22_DP
                              ! $ z_0 $ [km]
    real(DP), parameter:: z_1 = 30_DP
                              ! $ z_1 $[km]
    real(DP), parameter:: u_0 = 50_DP
                              ! $ u_0 $ [m s^-1]


    ! ѿ
    ! Work variables
    !
    integer:: i               ! ˲ DO 롼Ѻѿ
                              ! Work variables for DO loop in longitude
    integer:: j               ! ˲ DO 롼Ѻѿ
                              ! Work variables for DO loop in latitude
    integer:: k               ! ľ˲ DO 롼Ѻѿ
                              ! Work variables for DO loop in vertical direction

    ! Polvani et al. (2004) Ѥκѿ
    ! Work variables for Polvani et al. (2004)
    !
    !
                              ! $ \varphi $ [rad.] . . Latitude

    real(DP):: z_Height (1:kmax)
                              ! [km]
                              ! $ p $ [km] . . Height
    real(DP):: z_F (1:kmax)
                              ! F(z)
    real(DP):: z_F_z (1:kmax)
                              ! F(z)  z ʬ.
    real(DP) :: yz_Temp_A  (1:jmax, 1:kmax)
                              ! $ T $ [K] . . Temperature
    real(DP) :: yz_Temp_AA  (1:jmax, 1:kmax)
                              ! $ T $ [K] . yz_Temp_A ʬ. Temperature
    real(DP) :: z_Temp  (1:kmax)
                              ! $ T $ [K] . ʿѤ . Temperature
    real(DP):: yz_C (1:jmax,1:kmax)
                              ! T  \varphi ʬ.
    real(DP):: z_CCC (1:kmax)
                              ! yz_Temp_A ʬ.
    real(DP):: T_us (1:kmax)
                              ! T [K]. U.S. standard Atmosphere ˴Ť٥ץե.
    real(DP):: T_0 (1:kmax)
                              ! T [K]. پ׻Ȥʬ. 
    real(DP):: z_T_check (1:kmax)
                              ! T [K]. ʿѤ z_Temp  T_us κ. 

   ! ¹ʸ ; Executable statement

   ! ٤ˤĤ
   ! Calculate Height
   !
   ! U.S. standard Atmosphere ˴Ť٥ץե

   do k = 1, kmax
     z_Height = -ScaleHeight*log(z_Sigma)
   end do

   do k = 1, kmax
     if ((z_Height(k).ge.0.0_DP).and.(z_Height(k).lt.11.0_DP)) then
       T_us(k) = 288.15_DP - 6.5_DP*z_Height(k)
     else if ((z_Height(k).ge.11.0_DP).and.(z_Height(k).lt.20.0_DP)) then
       T_us(k) = 216.65_DP
     else if ((z_Height(k).ge.20.0_DP).and.(z_Height(k).lt.32.0_DP)) then
       T_us(k) = 216.65_DP + 1.0_DP*(z_Height(k)-20.0_DP)
     else if ((z_Height(k).ge.32.0_DP).and.(z_Height(k).lt.47.0_DP)) then
       T_us(k) = 228.65_DP + 2.8_DP*(z_Height(k)-32.0_DP)
     else if ((z_Height(k).ge.47.0_DP).and.(z_Height(k).lt.51.0_DP)) then
       T_us(k) = 270.65_DP
     else if ((z_Height(k).ge.51.0_DP).and.(z_Height(k).lt.71.0_DP)) then
       T_us(k) = 270.65_DP - 2.8_DP*(z_Height(k)-51.0_DP)
     else if ((z_Height(k).ge.71.0_DP).and.(z_Height(k).lt.80.0_DP)) then
       T_us(k) = 214.65_DP - 2.0_DP*(z_Height(k)-71.0_DP)
     else if (z_Height(k) .ge. 80.0_DP) then
       T_us(k) = 196.65_DP
     end if
   end do

    if ( .not. initial_data_inited ) call InitDataInit

      xyz_U    = 0.0_DP
      xyz_V    = 0.0_DP
      xyz_Temp = TempAvr
      xy_Ps    = PsAvr
      xyz_QVap = QVapAvr


      ! ®Ϳ
      ! Add eastward wind
      !
      do j = 1, jmax
        do k = 1, kmax
          z_Height(k)= -ScaleHeight * log(z_Sigma(k))
          z_F(k)= 0.5d0*(1.0d0-(tanh((z_Height(k)-z_0)/dz_0))**3)*(sin((PI*z_Height(k))/z_1))
          if (y_Lat(j) .gt. 0.0d0) then
            xyz_U(:,j,k) = u_0 * ((sin(PI*(sin(y_Lat(j)))**2))**3) * z_F(k)
          else
            xyz_U(:,j,k) =0.0d0
          end if
        end do
      end do


      ! پ׻
      ! Calculate temperature

        ! F(z)  z ʬ׻
        !
        z_F_z =  -1.5d0/dz_0                            &
               & * sin(PI*z_Height/z_1)                 &
               & * (                                    &
               &    (                                   &
               &     tanh(                              &
               &          (z_Height-z_0)/dz_0           &
               &         )                              &
               &    )                                   &
               &     **2/                               &
               &     (                                  &
               &      cosh(                             &
               &           (z_Height-z_0)/dz_0          &
               &          )                             &
               &     )                                  &
               &      **2                               &
               &   )                                    &
               & + 0.5d0 * PI/z_1*cos(PI*z_Height/z_1)  &
               & - 0.5d0 * (tanh(                       &
               &                 (z_Height-z_0)/dz_0    &
               &                )                       &
               &           )**3                         &
               & * PI/z_1                               &
               & * cos(PI*z_Height/z_1)

        ! T  \varphi ʬ׻
        !
        yz_C(:,:) = 0.0_DP
            do k = 1, kmax
          do j = 1, jmax
              if (y_Lat(j) .gt. 0d0) then
                yz_C(j,k) = - ScaleHeight/R                                  &
                         & * (2.0d0*a*omega*sin(y_Lat(j))                    &
                         &    +2.0d0*u_0*((sin(PI*(sin(y_Lat(j)))**2))**3)   &
                         &    *z_F(k)*tan(y_Lat(j)))                         &
                         & * u_0*((sin(PI*(sin(y_Lat(j)))**2))**3)*z_F_z(k)
              else
                yz_C(j,k) = 0.0d0
              end if
            end do
          end do

        ! T  \varphi ʬʬ
        !
        do k = 1, kmax
          yz_Temp_A(1,k) = 0.0d0
        end do

        do k = 1, kmax
          do j = 2, jmax
             if (y_Lat(j) .gt. 0) then
               yz_Temp_A(j,k) = yz_Temp_A(j-1,k) + 0.5 * ( yz_C(j,k)+yz_C(j-1,k) ) * (y_Lat(j)-y_Lat(j-1))
             else
               yz_Temp_A(j,k) = yz_Temp_A(1,k)
             end if
          end do
        end do

        ! T  \phi ʬʬ yz_Temp_A 򹹤ʬ
        !
        z_CCC(:) = 0.0_DP
          do k = 1, kmax
            do j = 1, jmax
               z_CCC(k) = z_CCC(k) &
                        & + yz_Temp_A(j,k) * y_Lat_Weight(j)
            end do
          end do

        do k = 1, kmax
          z_CCC(k) = z_CCC(k) / 2
        end do

        ! ʬ T_0 
        !
        do k = 1, kmax
            do j = 1, jmax
          T_0(k) = T_us(k) - z_CCC(k)
          end do
        end do

        ! βپ
        ! 嵭ǽ׻ޤȤ
        do k = 1, kmax
          do j = 1, jmax
              if (y_Lat(j) .gt. 0) then
                yz_Temp_AA(j,k) = yz_Temp_A(j,k) + T_0(k)
              else
                yz_Temp_AA(j,k) = T_0(k)
              end if
           write(*,*) j,k, yz_Temp_AA(j,k)
          end do
        end do

      ! پη׻ǤƤ뤫, ǧ
      ! 
      !
      z_Temp(:) = 0.0_DP
      do k = 1, kmax
        do j = 1, jmax
             z_Temp(k) = z_Temp(k) &
                       & + yz_Temp_AA(j,k) * y_Lat_Weight(j)
        end do
      end do
      z_Temp(1:kmax) = z_Temp(1:kmax) / 2

      do k = 1, kmax
          z_T_check(k) = z_Temp(k) - T_us(k)
          write(60,*) k, z_T_check(k), z_Temp(k), T_us(k)
      end do

    ! ٤˾Ϳ
    ! Add perturbation to temperature
    !

      !  0 , ̰ 45 ,  0 km 
      ! 濴ľͿ.
      !

      do k = 1, kmax
        do j = 1, jmax
          do i = 0, imax-1
            if ((x_Lon(i) .ge. 0) .and. (x_Lon(i) .lt. PI)) then
              xyz_Temp(i,j,k) =  yz_Temp_AA(j,k) &
                               & + (1/(cosh(3*(x_Lon(i))))**2)             &
                                 & * (1/(cosh(6*(y_Lat(j)-(PI/4))))**2)    &
                                 & * (1/(cosh(1*(z_Height(k)-0.0_DP)))**2) 
            else if ((x_Lon(i) .ge. PI) .and. (x_Lon(i) .lt. 2*PI)) then
              xyz_Temp(i,j,k) =  yz_Temp_AA(j,k) &
                               & + (1/(cosh(3*(x_Lon(i)-2*PI)))**2)        &
                                 & * (1/(cosh(6*(y_Lat(j)-(PI/4))))**2)    &
                                 & * (1/(cosh(1*(z_Height(k)-0.0_DP)))**2) 
            end if
          end do
        end do
      end do

  end subroutine Polvanietal2004InitData
!--------------------------------------------------------------------------------



  subroutine InitDataInit

    ! ⥸塼 ; USE statements
    !

    ! NAMELIST եϤ˴ؤ桼ƥƥ
    ! Utilities for NAMELIST file input
    !
    use namelist_util, only: namelist_filename, NmlutilMsg, NmlutilAryValid

    ! ե
    ! File I/O support
    !
    use dc_iounit, only: FileOpen

    ! ʸ
    ! Character handling
    !
    use dc_string, only: LChar

    ! ʸ ; Declaration statements
    !
    implicit none

    integer:: unit_nml        ! NAMELIST ե륪ץֹ. 
                              ! Unit number for NAMELIST file open
    integer:: iostat_nml      ! NAMELIST ɤ߹߻ IOSTAT. 
                              ! IOSTAT of NAMELIST read

    ! NAMELIST ѿ
    ! NAMELIST group name
    !
    namelist /initial_data_nml/ Pattern, &
      & TempAvr, PsAvr, QVapAvr, Ueq
          !
          ! ǥեͤˤĤƤϽ³ "initial_data#InitDataInit" 
          ! Υɤ򻲾ȤΤ. 
          !
          ! Refer to source codes in the initialization procedure
          ! "initial_data#InitDataInit" for the default values. 
          !


    ! ¹ʸ ; Executable statement

    if ( initial_data_inited ) return
    call InitCheck

    ! ǥեͤ (ޤ Pattern Τ)
    ! Default values settings (At first, "Pattern" only)
    !
    !Pattern = 'Small Disturbance of Temperature'
    Pattern = 'polvani et al. (2004)'
    !Pattern = 'AGCM 5.3 Default'

    ! NAMELIST ɤ߹ (ޤ Pattern Τ)
    ! NAMELIST is input (At first, "Pattern" only)
    !
    if ( trim(namelist_filename) /= '' ) then
      call FileOpen( unit_nml, &          ! (out)
        & namelist_filename, mode = 'r' ) ! (in)

      rewind( unit_nml )
      read( unit_nml, &             ! (in)
        & nml = initial_data_nml, & ! (out)
        & iostat = iostat_nml )     ! (out)
      close( unit_nml )

      call NmlutilMsg( iostat_nml, module_name ) ! (in)
    end if

    ! ǥեͤ
    ! Default values settings
    !
    select case ( LChar( trim(Pattern) ) )
    case ( 'polvani et al. (2004)' )
      TempAvr = 300.0_DP
      PsAvr   = 1.0e+5_DP
      QVapAvr = 0.0e0_DP
      Ueq     = 0.0_DP
    case ( 'small disturbance of temperature' )
      TempAvr = 250.0_DP
      PsAvr   = 1.0e+5_DP
      QVapAvr = 1.0e-10_DP
      Ueq     = 0.0_DP
    case ( 'agcm 5.3 default' )
      TempAvr = 250.0_DP
      PsAvr   = 1.0e+5_DP
      QVapAvr = 1.0e-10_DP
      Ueq     = 0.0_DP
    case ( 'sugiyama et al. (2008)' )
      TempAvr = 490.0_DP
      PsAvr   = 3.0e+6_DP
      QVapAvr = 6.11641e-3_DP
      Ueq     = 0.0_DP
    case default
      call MessageNotify( 'E', module_name, 'Pattern=<%c> is invalid.', &
        & c1 = trim(Pattern) )
    end select

    ! NAMELIST ɤ߹
    ! NAMELIST is input
    !
    if ( trim(namelist_filename) /= '' ) then
      call FileOpen( unit_nml, &          ! (out)
        & namelist_filename, mode = 'r' ) ! (in)

      rewind( unit_nml )
      read( unit_nml, &             ! (in)
        & nml = initial_data_nml, & ! (out)
        & iostat = iostat_nml )     ! (out)
      close( unit_nml )

      call NmlutilMsg( iostat_nml, module_name ) ! (in)
    end if


    !  ; Print
    !
    call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
    call MessageNotify( 'M', module_name, '  Pattern = %c', c1 = trim(Pattern) )
    call MessageNotify( 'M', module_name, '  TempAvr = %f', d = (/ TempAvr  /) )
    call MessageNotify( 'M', module_name, '  PsAvr   = %f', d = (/ PsAvr  /) )
    call MessageNotify( 'M', module_name, '  QVapAvr = %f', d = (/ QVapAvr  /) )
    call MessageNotify( 'M', module_name, '  Ueq     = %f', d = (/ Ueq  /) )
    call MessageNotify( 'M', module_name, '' )
    call MessageNotify( 'M', module_name, '  Scheme of saturation = %c', &
      & c1 = saturate_scheme )
    call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )

    initial_data_inited = .true.
  end subroutine InitDataInit

  !-------------------------------------------------------------------

  subroutine InitCheck
    !
    ! ¸⥸塼νå
    !
    ! Check initialization of dependency modules

    ! ⥸塼 ; USE statements
    !

    ! NAMELIST եϤ˴ؤ桼ƥƥ
    ! Utilities for NAMELIST file input
    !
    use namelist_util, only: namelist_util_inited

    ! ʻ
    ! Grid points settings
    !
    use gridset, only: gridset_inited

    ! ʪ
    ! Physical constants settings
    !
    use constants, only: constants_inited

    ! ɸǡ
    ! Axes data settings
    !
    use axesset, only: axesset_inited


    ! ¹ʸ ; Executable statement

    if ( .not. namelist_util_inited ) &
      & call MessageNotify( 'E', module_name, '"namelist_util" module is not initialized.' )

    if ( .not. gridset_inited ) &
      & call MessageNotify( 'E', module_name, '"gridset" module is not initialized.' )

    if ( .not. constants_inited ) &
      & call MessageNotify( 'E', module_name, '"constants" module is not initialized.' )

    if ( .not. axesset_inited ) &
      & call MessageNotify( 'E', module_name, '"axesset" module is not initialized.' )

  end subroutine InitCheck

end module initial_data
